<?php

namespace Drupal\entity_legal\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\RequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;

/**
 * Class EntityLegalSubscriber.
 *
 * @package Drupal\entity_legal\EventSubscriber
 */
class EntityLegalSubscriber implements EventSubscriberInterface {

  /**
   * Request event callback.
   *
   * @param \Symfony\Component\HttpKernel\Event\RequestEvent $event
   *   The request event.
   */
  public function checkRedirect(RequestEvent $event): void {
    $context = ['event' => $event];

    // Execute Redirect method plugin.
    \Drupal::service('plugin.manager.entity_legal')
      ->createInstance('redirect')
      ->execute($context);
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    $events[KernelEvents::REQUEST][] = ['checkRedirect', 28];
    return $events;
  }

}
